/*
 * Copyright (c) 2006-2007 Solexa
 * Author: Klaus Maisinger
 *
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 *
 */

#ifndef BASECALLCONFIG_H_
#define BASECALLCONFIG_H_

const char software[] = "Bustard";
const char software_version[] = "1.9.2";

const int   N_COLOURS  = 4;
const float max_score  = 40.; // maximum quality score
const int   mc_samples = 200; // number of Monte-Carlo samples

struct BasecallParameters {
    float PhasingRate;     // phasing rate
    float PrephasingRate;  // prephasing rate
    int   FirstCycle;      // first cycle to which the rates apply
    int   LastCycle;       // not used yet
    int   RestartFlag;     // not used yet
    BasecallParameters() : PhasingRate(0.), PrephasingRate(0.),
                           FirstCycle(0), LastCycle(-1), RestartFlag(1) {};
};

#endif /*BASECALLCONFIG_H_*/
