/*
 * Copyright (c) 2006-2007 Solexa
 * Authors: Klaus Maisinger, Lorenzo Milazzo
 *
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 *
 */

#ifndef _PHASINGMODEL_H
#define _PHASINGMODEL_H

#include <vector>
#include "BaseCallConfig.h"

class PhasingWindow
{
public:
    float value;
    int   cycle;
    PhasingWindow() { value = 0.; cycle = 0; }
};

class PhasingModel
{
private:
    std::vector<BasecallParameters> Reads; 
public:
    PhasingModel();
    PhasingModel(const struct BasecallParameters & params);
    PhasingModel(const std::vector<BasecallParameters> & params);
    PhasingModel(const struct BasecallParameters *params, int numParams);
    PhasingModel(const struct BasecallParameters & params,
                 std::vector<int> new_runs);
    virtual ~PhasingModel();
    virtual void addRead(const struct BasecallParameters & params);
    std::vector<PhasingWindow> getPhasingCorrection(int cycle, int ncycles, 
                                                    int *is_deblocked);
};

#endif /* _PHASINGMODEL_H */
