/*
 * Copyright (c) Solexa 2005, 2006
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */

#ifndef _TILING_H_
#define _TILING_H_

#include <string>

enum filename_type {
    POSITION_FILE,
    INDEX_FILE,
    INTENSITY_FILE,
    NOISE_FILE,
    HEADER_FILE,
    OFFSET_FILE,
    CLUSTER_FILE,
    QC_FILE,
    SIGNAL_FILE,
    SEQUENCE_FILE,
    PROBABILITY_FILE,
    SIGNAL2_FILE
};

class Tiling {
    std::string path;
    int *channelidx, *channelcount, nchannel, tileoffset;
public:
    Tiling(const char prefix[]);
    ~Tiling();
    void setLanes(int *chanidx, int *chancount, int nchan); 
    void setLane(int chanidx, int chanoffset, int ntiles = 1);
    std::string getIndexFilename(filename_type type, int idx,
                                 int cycle = -1, int colour = -1);
    std::string getTileFilename(filename_type type, int channel, int tile, 
                                  int cycle = -1, int colour = -1);
    int getLane(int idx);
    int getTile(int idx);
    int getIndex(int channel, int tile);
    std::string getFilePrefix();
};

#endif // _TILING_H_
