/*  Time-stamp: <26 Jun 2006 17:09 BST IOProcess.h km> */
/*
 * Copyright (c) Solexa 2006
 * Author:
 * Klaus Maisinger
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */

#ifndef _IOPROCESS_H
#define _IOPROCESS_H

int read_file(const char *filename,
              char      **buffer,
              long       *buffersize);
int read_gzip_file(const char filename[],
                   char      **buffer,
                   long       *buffersize);
int read_bzip2_file(const char filename[],
                    char      **buffer,
                    long       *buffersize);
int write_file(const char   filename[],
               const char * buffer,
               const long   buffersize);
int write_gzip_file(const char   filename[],
                    const char * buffer,
                    const long   buffersize);
int write_bzip2_file(const char   filename[],
                     const char * buffer,
                     const long   buffersize);

long file_size(char filename[]);
long fread_uchar_array(const char      filename[],
                       unsigned char * data,
                       long            nbytes,
                       long            offset = 0);
long fwrite_uchar_array(const char      filename[],
                        char            mode[],
                        unsigned char * data,
                        long            len);

long fread_ushort_array(const char       filename[],
                        unsigned short * data,
                        long             nelements,
                        long             offset = 0);
long fwrite_ushort_array(const char       filename[],
                         char             mode[],
                         unsigned short * data, 
                         long             nelem);

long fread_float_array(const char   filename[],
                       float      * data,
                       long         len,
                       long         offset = 0);
long fwrite_float_array(const char   filename[],
                        char         mode[],
                        float      * data,
                        long         len);

#if ! defined(_WIN32)
int open_tcp_socket(const char address[],
                    const int  port);
void send_uchar_file(const int sock,
                     const char          filename[],
                     const unsigned char data[],
                     const long          datalen);
#endif

#endif /* _IOPROCESS_H */
