/*
 * Copyright (c) Solexa 2006
 * Author:
 * Klaus Maisinger
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */
#ifndef INTENSITYDATA_H_
#define INTENSITYDATA_H_

#include <vector>
#include "ParameterTypes.h"

const int SIGNAL_COMPRESSION_NONE  = 0;
const int SIGNAL_COMPRESSION_GZIP  = 1;
const int SIGNAL_COMPRESSION_BZIP2 = 2;

int write_index_positions(const char       filename[],
                          const int        numClusters,
                          const int        lane,
                          const int        tile,
                          const Position * positions);

int write_signal_array(const char                    filename[],
                       const std::vector<float * > & signal,
                       const int                     numClusters, 
                       const int                     numChannels,
                       const int                     compression = SIGNAL_COMPRESSION_NONE,
                       const int                     lane = 0, 
                       const int                     tile = 0, 
                       const Position              * positions = 0);
int write_signal_array(const char   filename[],
                       float       *intensity,
                       const int    numClusters,
                       const int    numChannels,
                       const int    compression = SIGNAL_COMPRESSION_NONE);

int read_signal_array(const char   filename[],
                      float       *signal,
                      int         *numClusters,
                      int         *numChannels,
                      const int    compression = SIGNAL_COMPRESSION_NONE,
                      const int    skipcols = 0);
std::vector<float * > read_signal_array(const char *filename,
                                        int        *numClusters,
                                        int        *numChannels,
                                        int        *error,
                                        const int   compression = 0,
                                        const int   offset = 4);

#endif /*INTENSITYDATA_H_*/
