/*
 * Copyright (c) 2006 Solexa Ltd.
 * Author: Lorenzo Milazzo
 *
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */


#include <fstream>
#include <string>

#include "display_xtalk_mx.h"


void displayXTalkMx(Matrix & mx)
{
    std::string bases("ACGT");

    std::cout.setf(std::ios::fixed, std::ios::floatfield);
    std::cout.precision(2);

    for (int i = 0; i < int(bases.size()); ++i) {
        std::cout << "> " << bases.at(i) << std::endl;
    }

    for (int r = 0; r < mx.rows; ++r) {
        for (int c = 0; c < mx.cols; ++c) {
            std::cout << mx.data[c + r * mx.cols] << " ";
        }
        std::cout << std::endl;
    }

}
