/*
 * Copyright (c) 2006 Solexa Ltd.
 * Author: Lorenzo Milazzo
 *
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */


#include <fstream>
#include <string>

#include "output_process.h"
#include "savinio_common.h"


OutputProcess::OutputProcess(const char *output_file)
:fs_out(output_file)
{
}

void OutputProcess::toOutput_Matrix(const Matrix & mx)
{
    std::string bases("ACGT");

    fs_out.setf(std::ios::fixed, std::ios::floatfield);
    fs_out.precision(2);

    for (int i = 0; i < int(bases.size()); ++i) {
        fs_out << "> " << bases.at(i) << std::endl;
    }

    for (int r = 0; r < mx.rows; ++r) {
        for (int c = 0; c < mx.cols; ++c) {
            fs_out << mx.data[c + r * mx.cols] << " ";
        }
        fs_out << std::endl;
    }

}
