/*
 * Copyright (c) 2006 Solexa Ltd.
 * Author: Lorenzo Milazzo
 *
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 *
 */


#ifndef __NORMALISE_XTALK_MX_H__
#define __NORMALISE_XTALK_MX_H__

#include "savinio_common.h"


float scaleDistr(const int no_el1, const int no_el2, float *distr1,
                 float *distr2);
void scaleXTalkMx(const int no_i_values_bA, const int no_i_values_bC,
                  const int no_i_values_bG, const int no_i_values_bT,
                  float *i_data_bA_s, float *i_data_bC_s, float *i_data_bG_s,
                  float *i_data_bT_s, Matrix & mx_unscaled,
                  Matrix & mx_scaled);
void normaliseXTalkMx(Matrix & mx_scaled, Matrix & mx_normalised);
void scale_normaliseXTalkMx(const float * i_data,
                            const int     no_objects,
                            const int     no_cols,
                            Matrix      & mx_unscaled,
                            Matrix      & mx_normalised);


#endif /* __NORMALISE_XTALK_MX_H__ */
