/*  Time-stamp: <26 Jun 2006 17:05 BST ProcessFilter.h km> */
/*
 * Copyright (c) Solexa 2004, 2005, 2006
 * Author:
 * Klaus Maisinger
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */
#ifndef _PROCESS_FILTER_H
#define _PROCESS_FILTER_H

void get_fourier_dimensions(int minwidth, int nx, int ny, int *fnx, int *fny);
void pad_zero(float *image, int sizex, int sizey, int edgex, int edgey);
void pad_linear(float *image, int sizex, int sizey, int edgex, int edgey);
void filter_image_fft(float *image, float *filter_image, 
		      int nx, int ny, 
		      void (*func)(float *, int, int, void *), void *args,
		      float *fourier_image, int fnx, int fny);
void filter_image_fft(float *image, float *filter_image, 
		      int nx, int ny, 
		      void (*func)(float *, int, int, void *), void *args,
		      float width);
void make_identity_filter(float *mask, int nx, int ny, void *args);
void make_gaussian_highpass(float *mask, int nx, int ny, void *arg);
void make_mexican_hat_fft_mask(float *mask, int nx, int ny, void *arg);

#endif /* _PROCESS_FILTER_H */
