/*  Time-stamp: <26 Jun 2006 16:52 BST Tools.h km> */
/*
 * Copyright (c) Solexa 2005, 2006
 * Author: Klaus Maisinger
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */

#ifndef _TOOLS_H
#define _TOOLS_H

#if defined(TRACE_ON) || (! (defined(__GNUC__) || defined(__INTEL_COMPILER)))
#include <stdio.h>
#define TRACE printf
#else
#define TRACE(...) do { } while(0)
#endif

float *identity_matrix(int n);
void initialise_array(float *a, int n, float value = 0.);
void add_array(float *result, float *array1, float *array2, int n);
void subtract_array(float *result, float *array1, float *array2, int n);
void threshold_array(float *result, float *array, float *threshold,
                     float factor, int n, float default_value = 0.);

void get_array_stats(float *image, int n, float *average, float *sdev);
void get_array_min_max(float *array, int n, float *min, float *max);
void get_genopsys_autoscale(float *im, int nx, int ny,
                            float *min, float *max);
void get_genopsys_autoscale(unsigned short *im, int nx, int ny,
                            unsigned int *min, unsigned int *max);
void get_threshold_average(float *array, int n,
                           float *thresholds, float factor, 
                           float *above, float *below);
void bin(float *image, int n, int *hist, int ntotbins,
         float minval, float width);
void snprint_matrix(char s[], int nmax, float *matrix, int n1, int n2);

#endif /* _TOOLS_H */
