/*
 * Copyright (c) 2007 Illumina
 * Author: Klaus Maisinger
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */

#ifndef XMLIMAGECONFIGHANDLER_H_
#define XMLIMAGECONFIGHANDLER_H_

#include "XMLContentHandler.h"
#include "ParameterTypes.h"

class XMLImageConfigHandler : public XMLContentHandler
{
public:
    XMLImageConfigHandler();
    virtual ~XMLImageConfigHandler();
    virtual void startElement(const char name[], const Attributes *attr = 0);
    virtual void endElement(const char name[]);
    virtual void characters(const char ch[], int start, int length);
    virtual void getParameters(struct AnalysisParameters &params);
private:
    int inParameters;
    int inFwhm;
    int inThreshold;
    int inDistance;
    struct AnalysisParameters params;
};

#endif /*XMLIMAGECONFIGHANDLER_H_*/
