#!/usr/bin/env perl

# PROJECT: GERALD
# MODULE:  pickBestAlignment.pl
# AUTHOR:  A. J. Cox
#
# Copyright (c) 2007 Solexa
# This source file is covered by the "Solexa Public Source License"
# agreement and bound by the terms therein.


use warnings;
use strict;
#use File::Basename;

use FindBin;
use lib "$FindBin::Bin/../";
use Gerald::Common;
use POSIX;

my $version;
my $id;
{
    my $cvs_id='@(#) $Id: pickBestAlignment.pl,v 1.10 2007/12/10 16:18:31 tc Exp $';
    my $cvs_version='$Revision: 1.10 $';
    # Make CVS tag into a displayable string
    $version=$cvs_version;
    $version=~s/\$//g;
    $version=~s/Revision//;
    $id=$cvs_id;
#    $id=~s/\$//g;
} #scope

# usage paste qv eland_multi frag | $0
my ($qv, $readID, $read, $nhood, $positions, $details, $exactScore);

# most functions moved to Common.pm

my ($chrom, $pos, $strand, $type, $score);

die "Usage: $0 readLengthELAND" unless (@ARGV==1);

my ($readLengthELAND)=@ARGV;

while (<STDIN>)
{
    chomp;
    # print "PROCESSING: $_\n";
    ($qv, $readID, $read, $nhood, $details)=split("\t",$_);
    
    $exactScore=getExactScoreForRead($qv);

    ($chrom, $pos, $strand, $type, $score)
	=pickBestSingleReadAlignment($qv, $nhood, $details, $readLengthELAND,
				     $exactScore);

    unless (defined($pos))
    {
	print "$readID\t$nhood\n";
    } # if
    else
    {
	print "$readID\t$chrom\t$pos\t$strand\t$type\t$score\n";
    } # else

} # while
       
	   
