#!/usr/bin/env python
#
# Copyright (c)  2007 Illumina
# Authors:       Richard Shaw
#                Klaus Maisinger
# This source file is covered by the "Solexa Public Source License"
# agreement and bound by the terms therein.

import sys

"""Select new best size parameters."""

#------------------------------------------------------------------------------

def usage():
    print "Usage: %s <size summary file>" % sys.argv[0]
    sys.exit(0)

#------------------------------------------------------------------------------
if __name__ == "__main__":
    if len(sys.argv) < 2:
        usage()
    filename = sys.argv[1]
    try:
        lines = open(filename).readlines()
    except:
        common.error("Failed to read %s" % filename)
        sys.exit(1)
    sizes = []
    for line in lines:
        try:
            median = float(line.split()[5])
        except:
            common.error("Error parsing %s" % filename)
            sys.exit(1)
        sizes.append(median)
    sizes.sort()
    median = sizes[len(sizes)/2]
    print '<?xml version="1.0" encoding="utf-8"?>'
    print '<fwhmXml xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">'
    print '  <fwhm>%f</fwhm>' % median
    print '</fwhmXml>'

#------------------------------------------------------------------------------
