/*
 * Copyright (c) Solexa 2006
 * Author:
 * Klaus Maisinger
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */
#ifndef _OPTIMISE_H
#define _OPTIMISE_H

void bracket(float (*func) (float, void *), void *args, float *xa,
	     float *xb, float *xc, float *fa, float *fb, float *fc);
int brent(float (*func)(float, void*), void *args, float *xbracket, float xtol,
          float *xmin, float *fmin, int *funcallcount);
int LM_1d(float x[], float y[], float sig[], int ndata,
          float a[], int ia[], int na, float *chisq,
          float (*func)(float , float [], float [], int));
int LM_2d(float x[], float x2[], float y[], float sig[], int ndata,
          float a[], int ia[], int na, float *chisq,
          float (*func)(float, float, float [], float [], int));

float LM_gauss_1d_der(float x, float a[], float dyda[], int na);
float LM_gauss_1d(float x, float a[], int na);
float LM_gauss_2d(float x1, float x2, float a[], int na);
float LM_gauss_2d_der(float x1, float x2, float a[], float dyda[], int na);
float LM_gauss_spherical_2d(float x1, float x2, float a[], int na);
float LM_gauss_spherical_2d_der(float x1, float x2, float a[], float dyda[], int na);

#endif /* _OPTIMISE_H */
